/* NB - this is derived from Raspberry code I found in "picotool" (unused).
 * So it's got the LICENSE.TXT here. */

#include <stdint.h>
#include <string.h>
#include <stdio.h>

uint32_t crc32_for_byte(uint32_t remainder) {
    const uint32_t POLYNOMIAL = 0x4C11DB7;
    remainder <<= 24u;
    for (int bit = 8; bit > 0; bit--) {
        if (remainder & 0x80000000)
            remainder = (remainder << 1) ^ POLYNOMIAL;
        else
            remainder = (remainder << 1);
    }
    return remainder;
}

uint32_t crc32_sw(const uint8_t *buf, int count, uint32_t crc) {
    static uint32_t table[0x100] = { 0 };
    if (!table[1]) {
        for (int i = 0; i < 256; i++) {
            table[i] = crc32_for_byte(i);
        }
    }
    for (int i = 0; i < count; ++i) {
        crc = (crc << 8u) ^ table[(uint8_t) ((crc >> 24u) ^ buf[i])];
    }
    return crc;
}

int
main(void)
{
	unsigned char buf[1000];
	int n = fread(buf, 1, sizeof buf, stdin);
	if (n < 0) { perror("fread"); return -1; }
	printf("%u\n", crc32_sw(buf, n, 0xffffffff));
}
